package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLScheduleNode_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLScheduleNode extends JNIObject  {
	
	/* @generated */
	protected ISLScheduleNode(long ptr) {
		/*** PROTECTED REGION ID(ISLScheduleNode_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	static ISLScheduleNode build(long ptr) {
		if (isISLScheduleBandNode(ptr)) {
			return new ISLScheduleBandNode(ptr);
		} else 
		if (isISLScheduleContextNode(ptr)) {
			return new ISLScheduleContextNode(ptr);
		} else 
		if (isISLScheduleDomainNode(ptr)) {
			return new ISLScheduleDomainNode(ptr);
		} else 
		if (isISLScheduleExpansionNode(ptr)) {
			return new ISLScheduleExpansionNode(ptr);
		} else 
		if (isISLScheduleExtensionNode(ptr)) {
			return new ISLScheduleExtensionNode(ptr);
		} else 
		if (isISLScheduleFilterNode(ptr)) {
			return new ISLScheduleFilterNode(ptr);
		} else 
		if (isISLScheduleGuardNode(ptr)) {
			return new ISLScheduleGuardNode(ptr);
		} else 
		if (isISLScheduleLeafNode(ptr)) {
			return new ISLScheduleLeafNode(ptr);
		} else 
		if (isISLScheduleMarkNode(ptr)) {
			return new ISLScheduleMarkNode(ptr);
		} else 
		if (isISLScheduleSequenceNode(ptr)) {
			return new ISLScheduleSequenceNode(ptr);
		} else 
		if (isISLScheduleSetNode(ptr)) {
			return new ISLScheduleSetNode(ptr);
		} else 
		{
			return new ISLScheduleNode(ptr);
		}
	}
	//Instance of methods for subclasses
	/* @generated */
	private static boolean isISLScheduleBandNode(long ptr) {
		if (ISLNative.isl_schedule_node_is_band(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLScheduleBandNode() {
		return isISLScheduleBandNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLScheduleContextNode(long ptr) {
		if (ISLNative.isl_schedule_node_is_context(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLScheduleContextNode() {
		return isISLScheduleContextNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLScheduleDomainNode(long ptr) {
		if (ISLNative.isl_schedule_node_is_domain(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLScheduleDomainNode() {
		return isISLScheduleDomainNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLScheduleExpansionNode(long ptr) {
		if (ISLNative.isl_schedule_node_is_expansion(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLScheduleExpansionNode() {
		return isISLScheduleExpansionNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLScheduleExtensionNode(long ptr) {
		if (ISLNative.isl_schedule_node_is_extension(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLScheduleExtensionNode() {
		return isISLScheduleExtensionNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLScheduleFilterNode(long ptr) {
		if (ISLNative.isl_schedule_node_is_filter(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLScheduleFilterNode() {
		return isISLScheduleFilterNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLScheduleGuardNode(long ptr) {
		if (ISLNative.isl_schedule_node_is_guard(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLScheduleGuardNode() {
		return isISLScheduleGuardNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLScheduleLeafNode(long ptr) {
		if (ISLNative.isl_schedule_node_is_leaf(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLScheduleLeafNode() {
		return isISLScheduleLeafNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLScheduleMarkNode(long ptr) {
		if (ISLNative.isl_schedule_node_is_mark(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLScheduleMarkNode() {
		return isISLScheduleMarkNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLScheduleSequenceNode(long ptr) {
		if (ISLNative.isl_schedule_node_is_sequence(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLScheduleSequenceNode() {
		return isISLScheduleSequenceNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLScheduleSetNode(long ptr) {
		if (ISLNative.isl_schedule_node_is_set(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLScheduleSetNode() {
		return isISLScheduleSetNode(getNativePtr(this));
	}
	
	/*** PROTECTED REGION ID(ISLScheduleNode_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_schedule_node_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLScheduleNode node, int format) { 
		/*** PROTECTED REGION ID(static_isl_schedule_node_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_to_string(getNativePtr(node), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_schedule_node_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_schedule_node_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_copy 
	 * 
	 * @generated
	**/
	public ISLScheduleNode copy() {
		/*** PROTECTED REGION ID(isl_schedule_node_copy) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_schedule_node_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_schedule_node_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_is_equal 
	 * 
	 * @generated
	**/
	public boolean isSamePositionInTheSameSchedule(ISLScheduleNode node2) {
		/*** PROTECTED REGION ID(isl_schedule_node_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_is_equal(getNativePtr(this), getNativePtr(node2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_type 
	 * 
	 * @generated
	**/
	public ISLScheduleNodeType getType() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_type) DISABLED START ***/
		ISLScheduleNodeType res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLScheduleNodeType.build(ISLNative.isl_schedule_node_get_type(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_parent_type 
	 * 
	 * @generated
	**/
	public ISLScheduleNodeType getParentType() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_parent_type) DISABLED START ***/
		ISLScheduleNodeType res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLScheduleNodeType.build(ISLNative.isl_schedule_node_get_parent_type(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_schedule 
	 * 
	 * @generated
	**/
	public ISLSchedule getSchedule() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_schedule) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_node_get_schedule(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_has_parent 
	 * 
	 * @generated
	**/
	public boolean hasParent() {
		/*** PROTECTED REGION ID(isl_schedule_node_has_parent) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_has_parent(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_parent 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleNode parent() {
		/*** PROTECTED REGION ID(isl_schedule_node_parent) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_parent(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_root 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleNode root() {
		/*** PROTECTED REGION ID(isl_schedule_node_root) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_root(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_ancestor 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleNode ancestor(int generation) {
		/*** PROTECTED REGION ID(isl_schedule_node_ancestor) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_ancestor(getNativePtr(this), generation));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_n_children 
	 * 
	 * @generated
	**/
	public int getNbChildren() {
		/*** PROTECTED REGION ID(isl_schedule_node_n_children) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_n_children(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_child 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleNode child(int pos) {
		/*** PROTECTED REGION ID(isl_schedule_node_child) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_child(getNativePtr(this), pos));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_has_children 
	 * 
	 * @generated
	**/
	public boolean hasChildren() {
		/*** PROTECTED REGION ID(isl_schedule_node_has_children) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_has_children(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_first_child 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleNode firstChild() {
		/*** PROTECTED REGION ID(isl_schedule_node_first_child) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_first_child(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_has_previous_sibling 
	 * 
	 * @generated
	**/
	public boolean hasPreviousSibling() {
		/*** PROTECTED REGION ID(isl_schedule_node_has_previous_sibling) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_has_previous_sibling(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_previous_sibling 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleNode previousSibling() {
		/*** PROTECTED REGION ID(isl_schedule_node_previous_sibling) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_previous_sibling(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_has_next_sibling 
	 * 
	 * @generated
	**/
	public boolean hasNextSibling() {
		/*** PROTECTED REGION ID(isl_schedule_node_has_next_sibling) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_has_next_sibling(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_next_sibling 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleNode nextSibling() {
		/*** PROTECTED REGION ID(isl_schedule_node_next_sibling) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_next_sibling(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_tree_depth 
	 * 
	 * @generated
	**/
	public int getTreeDepth() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_tree_depth) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_get_tree_depth(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_child_position 
	 * 
	 * @generated
	**/
	public int getPositionInParentChildren() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_child_position) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_get_child_position(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_ancestor_child_position 
	 * 
	 * @generated
	**/
	public int getPositionInAncestorChildren(ISLScheduleNode ancestor) {
		/*** PROTECTED REGION ID(isl_schedule_node_get_ancestor_child_position) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_get_ancestor_child_position(getNativePtr(this), getNativePtr(ancestor));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_child 
	 * 
	 * @generated
	**/
	public ISLScheduleNode getChild(int pos) {
		/*** PROTECTED REGION ID(isl_schedule_node_get_child) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_get_child(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_shared_ancestor 
	 * 
	 * @generated
	**/
	public ISLScheduleNode getSharedAncestor(ISLScheduleNode node2) {
		/*** PROTECTED REGION ID(isl_schedule_node_get_shared_ancestor) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_get_shared_ancestor(getNativePtr(this), getNativePtr(node2)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_cut 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleLeafNode cut() {
		/*** PROTECTED REGION ID(isl_schedule_node_cut) DISABLED START ***/
		ISLScheduleLeafNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = (ISLScheduleLeafNode)ISLScheduleLeafNode.build(ISLNative.isl_schedule_node_cut(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_delete 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleNode delete() {
		/*** PROTECTED REGION ID(isl_schedule_node_delete) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_delete(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_is_subtree_anchored 
	 * 
	 * @generated
	**/
	public boolean isSubtreeAnchored() {
		/*** PROTECTED REGION ID(isl_schedule_node_is_subtree_anchored) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_is_subtree_anchored(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_reset_user 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleNode resetUser() {
		/*** PROTECTED REGION ID(isl_schedule_node_reset_user) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_reset_user(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_align_params 
	 * 
	 * @take this space
	 * @generated
	**/
	public ISLScheduleNode alignParams(ISLSpace space) {
		/*** PROTECTED REGION ID(isl_schedule_node_align_params) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this, space);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_align_params(getNativePtr(this), getNativePtr(space)));
			} finally {
				taken(this);
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_prefix_schedule_multi_union_pw_aff 
	 * 
	 * @generated
	**/
	public ISLMultiUnionPWAff getPrefixScheduleAsMultiUnionPWAff() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_prefix_schedule_multi_union_pw_aff) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_schedule_node_get_prefix_schedule_multi_union_pw_aff(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_prefix_schedule_union_pw_multi_aff 
	 * 
	 * @generated
	**/
	public ISLUnionPWMultiAff getPrefixScheduleAsUnionPWMultiAff() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_prefix_schedule_union_pw_multi_aff) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_schedule_node_get_prefix_schedule_union_pw_multi_aff(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_prefix_schedule_union_map 
	 * 
	 * @generated
	**/
	public ISLUnionMap getPrefixScheduleAsUnionMap() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_prefix_schedule_union_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionMap.build(ISLNative.isl_schedule_node_get_prefix_schedule_union_map(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_prefix_schedule_relation 
	 * 
	 * @generated
	**/
	public ISLUnionMap getPrefixScheduleAsRelation() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_prefix_schedule_relation) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionMap.build(ISLNative.isl_schedule_node_get_prefix_schedule_relation(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_subtree_schedule_union_map 
	 * 
	 * @generated
	**/
	public ISLUnionMap getSubtreeSchedule() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_subtree_schedule_union_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionMap.build(ISLNative.isl_schedule_node_get_subtree_schedule_union_map(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_subtree_expansion 
	 * 
	 * @generated
	**/
	public ISLUnionMap getSubtreeExpansion() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_subtree_expansion) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionMap.build(ISLNative.isl_schedule_node_get_subtree_expansion(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_subtree_contraction 
	 * 
	 * @generated
	**/
	public ISLUnionPWMultiAff getSubtreeContraction() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_subtree_contraction) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_schedule_node_get_subtree_contraction(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_schedule_depth 
	 * 
	 * @generated
	**/
	public int getScheduleDepth() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_schedule_depth) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_get_schedule_depth(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_domain 
	 * 
	 * @generated
	**/
	public ISLUnionSet getDomain() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_domain) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionSet.build(ISLNative.isl_schedule_node_get_domain(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_get_universe_domain 
	 * 
	 * @generated
	**/
	public ISLUnionSet getUniverseDomain() {
		/*** PROTECTED REGION ID(isl_schedule_node_get_universe_domain) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionSet.build(ISLNative.isl_schedule_node_get_universe_domain(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_insert_partial_schedule 
	 * 
	 * @take this schedule
	 * @generated
	**/
	public ISLScheduleBandNode insertPartialSchedule(ISLMultiUnionPWAff schedule) {
		/*** PROTECTED REGION ID(isl_schedule_node_insert_partial_schedule) DISABLED START ***/
		ISLScheduleBandNode res;
		
		synchronized(LOCK) {
			checkParameters(this, schedule);
			try {
				res = (ISLScheduleBandNode)ISLScheduleBandNode.build(ISLNative.isl_schedule_node_insert_partial_schedule(getNativePtr(this), getNativePtr(schedule)));
			} finally {
				taken(this);
				taken(schedule);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_insert_context 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLScheduleContextNode insertContext(ISLSet context) {
		/*** PROTECTED REGION ID(isl_schedule_node_insert_context) DISABLED START ***/
		ISLScheduleContextNode res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = (ISLScheduleContextNode)ISLScheduleContextNode.build(ISLNative.isl_schedule_node_insert_context(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_insert_filter 
	 * 
	 * @take this filter
	 * @generated
	**/
	public ISLScheduleFilterNode insertFilter(ISLUnionSet filter) {
		/*** PROTECTED REGION ID(isl_schedule_node_insert_filter) DISABLED START ***/
		ISLScheduleFilterNode res;
		
		synchronized(LOCK) {
			checkParameters(this, filter);
			try {
				res = (ISLScheduleFilterNode)ISLScheduleFilterNode.build(ISLNative.isl_schedule_node_insert_filter(getNativePtr(this), getNativePtr(filter)));
			} finally {
				taken(this);
				taken(filter);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_insert_guard 
	 * 
	 * @take this guard
	 * @generated
	**/
	public ISLScheduleGuardNode insertGuard(ISLSet guard) {
		/*** PROTECTED REGION ID(isl_schedule_node_insert_guard) DISABLED START ***/
		ISLScheduleGuardNode res;
		
		synchronized(LOCK) {
			checkParameters(this, guard);
			try {
				res = (ISLScheduleGuardNode)ISLScheduleGuardNode.build(ISLNative.isl_schedule_node_insert_guard(getNativePtr(this), getNativePtr(guard)));
			} finally {
				taken(this);
				taken(guard);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_insert_mark 
	 * 
	 * @take this mark
	 * @generated
	**/
	public ISLScheduleMarkNode insertMark(ISLIdentifier mark) {
		/*** PROTECTED REGION ID(isl_schedule_node_insert_mark) DISABLED START ***/
		ISLScheduleMarkNode res;
		
		synchronized(LOCK) {
			checkParameters(this, mark);
			try {
				res = (ISLScheduleMarkNode)ISLScheduleMarkNode.build(ISLNative.isl_schedule_node_insert_mark(getNativePtr(this), getNativePtr(mark)));
			} finally {
				taken(this);
				taken(mark);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_insert_sequence 
	 * 
	 * @take this filters
	 * @generated
	**/
	public ISLScheduleSequenceNode insertSequence(ISLUnionSetList filters) {
		/*** PROTECTED REGION ID(isl_schedule_node_insert_sequence) DISABLED START ***/
		ISLScheduleSequenceNode res;
		
		synchronized(LOCK) {
			checkParameters(this, filters);
			try {
				res = (ISLScheduleSequenceNode)ISLScheduleSequenceNode.build(ISLNative.isl_schedule_node_insert_sequence(getNativePtr(this), getNativePtr(filters)));
			} finally {
				taken(this);
				taken(filters);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_insert_set 
	 * 
	 * @take this filters
	 * @generated
	**/
	public ISLScheduleSetNode insertSet(ISLUnionSetList filters) {
		/*** PROTECTED REGION ID(isl_schedule_node_insert_set) DISABLED START ***/
		ISLScheduleSetNode res;
		
		synchronized(LOCK) {
			checkParameters(this, filters);
			try {
				res = (ISLScheduleSetNode)ISLScheduleSetNode.build(ISLNative.isl_schedule_node_insert_set(getNativePtr(this), getNativePtr(filters)));
			} finally {
				taken(this);
				taken(filters);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_group 
	 * 
	 * @take this group_id
	 * @generated
	**/
	public ISLScheduleNode group(ISLIdentifier group_id) {
		/*** PROTECTED REGION ID(isl_schedule_node_group) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this, group_id);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_group(getNativePtr(this), getNativePtr(group_id)));
			} finally {
				taken(this);
				taken(group_id);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_order_before 
	 * 
	 * @take this filter
	 * @generated
	**/
	public ISLScheduleNode orderBefore(ISLUnionSet filter) {
		/*** PROTECTED REGION ID(isl_schedule_node_order_before) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this, filter);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_order_before(getNativePtr(this), getNativePtr(filter)));
			} finally {
				taken(this);
				taken(filter);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_order_after 
	 * 
	 * @take this filter
	 * @generated
	**/
	public ISLScheduleNode orderAfter(ISLUnionSet filter) {
		/*** PROTECTED REGION ID(isl_schedule_node_order_after) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this, filter);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_order_after(getNativePtr(this), getNativePtr(filter)));
			} finally {
				taken(this);
				taken(filter);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_graft_before 
	 * 
	 * @take this graft
	 * @generated
	**/
	public ISLScheduleNode graftBefore(ISLScheduleNode graft) {
		/*** PROTECTED REGION ID(isl_schedule_node_graft_before) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this, graft);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_graft_before(getNativePtr(this), getNativePtr(graft)));
			} finally {
				taken(this);
				taken(graft);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_graft_after 
	 * 
	 * @take this graft
	 * @generated
	**/
	public ISLScheduleNode graftAfter(ISLScheduleNode graft) {
		/*** PROTECTED REGION ID(isl_schedule_node_graft_after) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters(this, graft);
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_node_graft_after(getNativePtr(this), getNativePtr(graft)));
			} finally {
				taken(this);
				taken(graft);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_to_str 
	 * 
	 * @generated
	**/
	public String toISLString() {
		/*** PROTECTED REGION ID(isl_schedule_node_to_str) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_node_to_str(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLScheduleNodeVisitor visitor) {
		visitor.visitISLScheduleNode(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLScheduleNode_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
